Loading...
Searching...
No Matches
halide_buffer_t Struct Reference

The raw representation of an image passed around by generated Halide code. More...

`#include <HalideRuntime.h>`

## Public Attributes

uint64_t | device
| A device-handle for e.g.
const struct halide_device_interface_t * | device_interface
| The interface used to interpret the above handle.
uint8_t * | host
| A pointer to the start of the data in main memory.
uint64_t | flags
| flags with various meanings.
struct halide_type_t | type
| The type of each buffer element.
int32_t | dimensions
| The dimensionality of the buffer.
halide_dimension_t * | dim
| The shape of the buffer.
void * | padding
| Pads the buffer up to a multiple of 8 bytes.

## Detailed Description

The raw representation of an image passed around by generated Halide code.

It includes some stuff to track whether the image is not actually in main memory, but instead on a device (like a GPU). For a more convenient C++ wrapper, use Halide::Buffer<T>.

Definition at line 1569 of file HalideRuntime.h.

## Member Data Documentation

## device

uint64_t halide_buffer_t::device

A device-handle for e.g.

GPU memory used to back this buffer.

Definition at line 1571 of file HalideRuntime.h.

Referenced by Halide::Runtime::Internal::make_buffer_copy().

## device_interface

const struct halide_device_interface_t* halide_buffer_t::device_interface

The interface used to interpret the above handle.

Definition at line 1574 of file HalideRuntime.h.

## host

uint8_t* halide_buffer_t::host

A pointer to the start of the data in main memory.

In terms of the Halide coordinate system, this is the address of the min coordinates (defined below).

Definition at line 1579 of file HalideRuntime.h.

Referenced by Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::data(), and Halide::Runtime::Internal::make_buffer_copy().

## flags

uint64_t halide_buffer_t::flags

flags with various meanings.

Definition at line 1582 of file HalideRuntime.h.

## type

struct halide_type_t halide_buffer_t::type

The type of each buffer element.

Definition at line 1585 of file HalideRuntime.h.

Referenced by Halide::Runtime::Internal::calc_device_crop_byte_offset(), Halide::Runtime::Internal::calc_device_slice_byte_offset(), and Halide::Runtime::Internal::make_buffer_copy().

## dimensions

int32_t halide_buffer_t::dimensions

The dimensionality of the buffer.

Definition at line 1588 of file HalideRuntime.h.

Referenced by Halide::Runtime::Internal::calc_device_crop_byte_offset(), and Halide::Runtime::Internal::make_buffer_copy().

## dim

halide_dimension_t* halide_buffer_t::dim

The shape of the buffer.

Halide does not own this array - you must manage the memory for it yourself.

Definition at line 1592 of file HalideRuntime.h.

Referenced by Halide::Runtime::Internal::calc_device_crop_byte_offset(), Halide::Runtime::Internal::calc_device_slice_byte_offset(), Halide::Runtime::Internal::make_buffer_copy(), and Halide::Runtime::Buffer< T, Dims, InClassDimStorage >::make_with_shape_of().

## padding

void* halide_buffer_t::padding

Pads the buffer up to a multiple of 8 bytes.

Definition at line 1595 of file HalideRuntime.h.

The documentation for this struct was generated from the following file:

- src/runtime/HalideRuntime.h